action_app/urls.py
from django.urls import path
from action_app import views

app_name = 'action_app'
urlpatterns = [
    path('make_action/', views.make_action, name='make_action'),
]

character_app/urls.py
from django.urls import path
from character_app import views

app_name = 'character_app'
urlpatterns = [
    path('create/', views.CharacterCreateView.as_view(), name='character-create'),
    path('list/', views.CharacterListView.as_view(), name='character-list'),
    path('detail/<int:pk>', views.CharacterDetailView.as_view(), name='character-detail'),
    path('update/<int:pk>', views.CharacterUpdateView.as_view(), name='character-update'),
    path('delete/<int:pk>', views.CharacterDeleteView.as_view(), name='character-delete'),

    path('fight/', views.fight, name='fight'),
    path('result/', views.result, name='result'),

]

rpg_app/urls.py
from django.contrib import admin
from django.urls import path
from django.urls import include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('character_app/', include('character_app.urls')),
    path('action_app/', include('action_app.urls')),
]

action_app/models.py
from django.db import models

# Create your models here.

character_app/models.py
from django.db import models
from django.shortcuts import reverse

CHARACTER_TYPE = [
    (1, "Przyjaciel"),
    (2, "Wróg"),
]

class Character(models.Model):
    name = models.CharField(max_length=30)
    type = models.IntegerField(choices=CHARACTER_TYPE)
    attack = models.IntegerField()
    defence = models.IntegerField()
    health_points = models.IntegerField()

    def __str__(self):
        return self.name

    def get_absolute_url(self):
        return reverse('character_app:character-list')


class Action(models.Model):
    character_1 = models.ForeignKey(Character, related_name="characters_1", on_delete=models.CASCADE)
    character_2 = models.ForeignKey(Character, related_name="characters_2", on_delete=models.CASCADE)

    def __str__(self):
        return f"{self.character_1} atakuje {self.character_2}"

character_app/forms.py
from django import forms
from character_app.models import Action

class ActionForm(forms.ModelForm):
    class Meta:
        model = Action
        fields = [
            "character_1",
            "character_2",

        ]

action_app/views.py
from django.shortcuts import render

def make_action(request):
    return render(
        request,
        'action_app/make_action.html'
    )
# Create your views here.

character_app/views.py
from django.urls import reverse_lazy
from django.shortcuts import render
from django.views.generic.list import ListView
from django.views.generic.detail import DetailView
from django.views.generic.edit import CreateView
from django.views.generic.edit import UpdateView
from django.views.generic.edit import DeleteView
from character_app.models import Character
from character_app.forms import ActionForm

# def create(request):
#                             # if request.method == "POST":
#                             #     new_value = request.POST.get('value')
#     return render(
#         request,
#         'character_app/create.html'
#     )
# Create your views here.

class CharacterListView(ListView):
    model = Character


class CharacterDetailView(DetailView):
    model = Character


class CharacterCreateView(CreateView):
    model = Character
    fields = [
        'name',
        'type',
        'attack',
        'defence',
        'health_points',
    ]

class CharacterUpdateView(UpdateView):
    model = Character
    fields = [
        'type',
        'attack',
        'defence',
        'health_points',
    ]
    template_name_suffix = "_update"

class CharacterDeleteView(DeleteView):
    model = Character
    success_url = reverse_lazy('character_app:character-list')


def fight(request):
    form = ActionForm()
    return render(
        request,
        'character_app/fight.html',
        context={
            'form': form,
        }
    )

def result(request):
    if request.method == 'POST':
        character_1_id = request.POST.get('character_1')
        character_2_id = request.POST.get('character_2')

        character_1 = Character.objects.get(id=character_1_id)
        character_2 = Character.objects.get(id=character_2_id)



        try:
            loss = character_1.attack / character_2.defence

        except ZeroDivisionError:
            loss = 0 + character_1.attack

        character_2.health_points = character_2.health_points - loss
        character_2.save()


        if character_2.health_points > 0:
            message = 'Postać ' + character_2.name + ' straciła ' + str(loss) + ' punktów życia. Posiada teraz ' + str(character_2.health_points)
        else:
            message = 'Postać ' + character_2.name + ' nie żyje :((('


        return render(
            request,
            'character_app/result.html',
            context={
                'message': message

            }
        )

action_app/templates/action_app/make_action.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Title</title>
</head>
<body>
    Wykonaj akcję -> Atak/Obrona
</body>
</html>

character_app/templates/character_app/character_confirm_delete.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Usuń postać</title>
</head>
<body>
    <form method="post">
        {% csrf_token %}
        <p>Czy na pewno chcesz usunąć postać {{ character }}?</p>
        <input type="submit" value="Potwierdź">
    </form>
</body>
</html>

character_app/templates/character_app/character_detail.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Statystyki {{ character }}</title>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.0/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-KyZXEAg3QhqLMpG8r+8fhAXLRk2vvoC2f3B09zVXn8CA5QIVfZOJ3BCsw2P0p/We" crossorigin="anonymous">
</head>
<body>

    <ul style="display: inline, margin:10%;">
        <h2>Postać nr {{ character.id }}</h2>
        <h3>Imię: {{ character.name }}</h3>
        <h4>Typ: {{ character.get_type_display }}</h4>
        <h5>Atak: {{ character.attack }}</h5>
        <h6>Obrona: {{ character.defence }}</h6>
        <h7>Punkty życia: {{ character.health_points }}</h7>

            <form action="{% url 'character_app:character-list' %}" method="get">
                {% csrf_token %}
                {{ form.as_p }}
                <input type="submit" value="Pokaż pozostałe postacie">
        </form>
    </ul>
</body>
</html>

character_app/templates/character_app/character_form.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Title</title>
</head>
<body>
    <h1>Stwórz postać:</h1>
    <form method = "post">
        {% csrf_token %}
        {{ form.as_p }}
        <input type="submit" value="Stwórz">
    </form>
</body>
</html>

character_app/templates/character_app/character_list.html
<!DOCTYPE html>
<html lang="en" xmlns:display="http://www.w3.org/1999/xhtml">
<head>
    <meta charset="UTF-8">
    <title>Widok listy</title>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.0/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-KyZXEAg3QhqLMpG8r+8fhAXLRk2vvoC2f3B09zVXn8CA5QIVfZOJ3BCsw2P0p/We" crossorigin="anonymous">
</head>
<body>
    <h5> Pokaż statystyki poszczególnych postaci:</h5>
        <ol>
        {% for character in object_list %}
            <li style="margin 10%">
                <a href="{% url 'character_app:character-detail' character.id %}">{{ character }}</a>
                <form method="get" action="{% url 'character_app:character-delete' character.id %}" style="display: inline;">
                    {% csrf_token %}
                    <input type="submit" value="Usuń" class="btn btn-danger btn-sm">
                </form>

                <a href="{% url 'character_app:character-detail' character.id %}"></a>
                <form method="get" action="{% url 'character_app:character-update' character.id %}" style="display: inline;">
                    {% csrf_token %}
                    <input type="submit" value="Edytuj" class="btn btn-primary btn-sm">
                </form>

            </li>
        {% endfor %}
        </ol>
            <ul style="margin 10%">
                <form action="{% url 'character_app:fight' %}" method="post">
                    {% csrf_token %}
                    {{ form.as_p }}
                    <input type="submit" value="Stwórz walkę">
                </form>
            </ul>
            <ul style="margin 10%">
                <form action="{% url 'character_app:character-create' %}" method="get">
                    {% csrf_token %}
                    {{ form.as_p }}
                    <input type="submit" value="Stwórz postać">
                </form>
            </ul>
</body>
</html>

character_app/templates/character_app/character_update.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Title</title>
</head>
<body>
    <h1>Edytuj postać: {{ character }}</h1>
    <form method = "post">
        {% csrf_token %}

        {{ form.as_p }}
        <input type="submit" value="Edytuj">
    </form>
</body>
</html>

character_app/templates/character_app/fight.html
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Walka</title>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.0/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-KyZXEAg3QhqLMpG8r+8fhAXLRk2vvoC2f3B09zVXn8CA5QIVfZOJ3BCsw2P0p/We" crossorigin="anonymous">
</head>
<body>
    <ul>
    Wybierz postacie:
     <li style="margin 10%;">
        <form action="{% url 'character_app:result' %}" method="post">
        {% csrf_token %}
        {{ form.as_p }}
        <input type="submit" value="Walcz!">
        </form>
     </li>
    </ul>
</body>
</html>

character_app/templates/character_app/result.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Wynik</title>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.0/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-KyZXEAg3QhqLMpG8r+8fhAXLRk2vvoC2f3B09zVXn8CA5QIVfZOJ3BCsw2P0p/We" crossorigin="anonymous">
</head>
<body>
    <ul style="margin 1%">
        {{ message }}
      <form action="{% url 'character_app:fight' %}" method="post">
        {% csrf_token %}
        {{ form.as_p }}
            <input type="submit" value="Stwórz kolejną walkę">
        </form>
    </ul>
    <ul>
        <form action="{% url 'character_app:character-list' %}" method="get">
        {% csrf_token %}
        {{ form.as_p }}
            <input type="submit" value="Wróć do listy postaci">
        </form>
    </ul>
</body>
</html>